package com.hzya.frame.sysnew.comparison.serviceData.service.impl;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.basedao.dao.MybatisGenericDao;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.mdm.mdmModuleSource.dao.impl.MdmModuleSourceDaoImpl;
import com.hzya.frame.mdm.mdmModuleSource.entity.MdmModuleSourceEntity;
import com.hzya.frame.sysnew.comparison.entity.ComparisonEntity;
import com.hzya.frame.sysnew.comparison.service.impl.ComparisonServiceImpl;
import com.hzya.frame.sysnew.comparison.serviceData.dao.IServiceDataDao;
import com.hzya.frame.sysnew.comparison.serviceData.dao.impl.ServiceDataDaoImpl;
import com.hzya.frame.sysnew.comparison.serviceData.service.IServiceDataService;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

@Service(value = "ServiceDataServiceImpl")
public class ServiceDataServiceImpl extends BaseService<ComparisonEntity,String> implements IServiceDataService {

    @Autowired
    private ServiceDataDaoImpl serviceDataDao;
    @Autowired
    private MdmModuleSourceDaoImpl mdmModuleSourceDaoImpl;
    @Autowired
    private ComparisonServiceImpl comparisonServiceimpl;
    @Override
    public JsonResultEntity queryDocumentView(JSONObject json) {
        JSONObject jsonObject = json.getJSONObject("jsonStr");
        //根据插件分类查询主数据来源表
        List<MdmModuleSourceEntity> list = mdmModuleSourceDaoImpl.MdmModuleSourceentityGroupByType();
        if (CollectionUtils.isEmpty(list)) {
            logger.info("没有类型为插件得数据,无法获取数据");
            return BaseResult.getFailureMessageEntity("数据来源表无插件类型");
        }
        for (MdmModuleSourceEntity mdmModuleSourceEntity : list) {
            String tableName = "";
            try {
                String appTyp = mdmModuleSourceEntity.getAppType();//系统类型  1、致远OA 2、用友U8C 3、用友BIP
                String dbCode = mdmModuleSourceEntity.getDbCode();//数据源编码
                String mdmCode = mdmModuleSourceEntity.getMdmCode();//主数据编码
                List<JSONObject> listAll  = new ArrayList<>();
                switch (appTyp){
                    case "1":
                        switch (mdmCode){
                            case "10045"://付款申请
                                tableName = "cmp_apply";
                                listAll = bindingDocument(jsonObject, mdmModuleSourceEntity, dbCode);
                                break;
                            default:
                                break;
                        }
                        break;
                    default:
                        break;
                }
                //将查询出来的数据进行组装，调用通用方法新增或者更新
                if (null != listAll && listAll.size() > 0) {
                    ParametricDocument(listAll, mdmCode, tableName);
                } else {
                    logger.info("U8C主数据档案没有需要同步中台的数据");
                }
            }catch (Exception e){
                logger.info("业务数据同步失败:{}",e.getMessage());
                e.printStackTrace();
            }
        }
        return BaseResult.getSuccessMessageEntity("业务数据同步成功");
    }

    private List<JSONObject> bindingDocument(JSONObject jsonObject, MdmModuleSourceEntity mdmModuleSourceEntity, String dbCode) {
        try {
            List<JSONObject> list = new ArrayList<>();
            StringBuffer sb = new StringBuffer();
            StringBuffer stringBuffer = new StringBuffer();
            stringBuffer.append("select oa_id as data_id,vdef1 as vdef1,applysum,pk_acceptorg,pk_group,pk_trantypecode,pk_busitype,\n" +
                    "                    pk_supplier,pk_bankacc_r as pk_bankacc_r\n" +
                    "                     from v_OA_TO_BIP where 1=1  " + sb.toString());
            mdmModuleSourceEntity.setDataSourceCode(dbCode);
            List<HashMap<String, Object>> hashMaps = serviceDataDao.queryListBySWSource(stringBuffer.toString(), mdmModuleSourceEntity);
            int i = 0;
            if (CollectionUtils.isNotEmpty(hashMaps)) {
                for (HashMap<String, Object> hashMap : hashMaps) {
                    JSONObject main = new JSONObject();
                    JSONObject cmp_apply = new JSONObject();
                    for (String key : hashMap.keySet()) {
                        cmp_apply.put(key, hashMap.get(key));
                    }
                    //获取明细信息
                    String formmainId = (String) hashMap.get("data_id");
                    StringBuffer stringBufferDetails = new StringBuffer();
                    stringBufferDetails.append("select d_id as data_id,tab_name,pk_supplier,pk_bankacc_r,pk_currtype,vdef1,vdef2,vdef3,vdef4\n" +
                            "                             from v_OA_TO_BIP_DETAILS where formmain_id= '"+formmainId+"' " );
                    List<HashMap<String, Object>> hashMapsDetails = serviceDataDao.queryListBySWSource(stringBufferDetails.toString(),mdmModuleSourceEntity);
                    JSONArray cmp_apply_b = new JSONArray();
                    if(CollectionUtils.isNotEmpty(hashMapsDetails)){
                        for (HashMap<String, Object> detailsMap : hashMapsDetails) {
                            JSONObject details = new JSONObject();
                            for (String key : detailsMap.keySet()) {
                                details.put(key, detailsMap.get(key));
                            }
                            cmp_apply_b.add(details);
                        }
                    }
                    main.put("cmp_apply_b",cmp_apply_b);
                    main.put("cmp_apply", cmp_apply);
                    list.add(main);
                }
            }
            return list;
        } catch (Exception e) {
            logger.info("组装单据是图查询参数失败:{}", e.getMessage());
            e.printStackTrace();
        }
        return null;
    }

    private JsonResultEntity ParametricDocument(List<JSONObject>  hashMaps,String mdmCode,String tableName){
        try {
            for (JSONObject hashMap : hashMaps) {
                JSONObject main = hashMap.getJSONObject(tableName);
                JSONObject jsonObjectUser = new JSONObject();
                JSONObject jsonStr = new JSONObject();
                jsonObjectUser.put("data_id", main.get("data_id"));
                jsonObjectUser.put("mdmCode", mdmCode);
                jsonStr.put("jsonStr", jsonObjectUser);
                //先查询编码和名称查询是否存在
                Object attribute = comparisonServiceimpl.queryEntityPage(jsonStr);
                logger.info("得到的attribute值为：{}", jsonStr.toJSONString(attribute));
                JSONObject jsonObjectAttribute = (JSONObject) JSON.toJSON(attribute);
                JSONObject pageInfo = jsonObjectAttribute.getJSONObject("pageInfo");
                JSONArray jsonArrayList = pageInfo.getJSONArray("list");
                //如果jsonArrayList为null，说明没有值，在表中不存在
                if (jsonArrayList == null || jsonArrayList.size() == 0) {
                    hashMap.put("appName","数智中台");
                    hashMap.put("appCode","800004");
                    hashMap.put("mdmCode", mdmCode);
                    hashMap.put("optionName", "数智中台");
                    jsonStr.put("jsonStr", hashMap);
                    Object result = comparisonServiceimpl.saveEntity(jsonStr);
                    logger.info("单据视图新增结果为：{}", JSON.toJSONString(result));
                } else {
                    hashMap.put("appName","数智中台");
                    hashMap.put("appCode","800004");
                    hashMap.put("mdmCode", mdmCode);
                    hashMap.put("optionName", "数智中台");
                    jsonStr.put("jsonStr", hashMap);
                    Object result = comparisonServiceimpl.updateEntity(jsonStr);
                    logger.info("单据视图更新结果为：{}", JSON.toJSONString(result));
                }
            }
        }catch (Exception e){
            logger.info("将数据查询之后进行组装调用通用方法错误:{}",e.getMessage());
            e.printStackTrace();
        }
        return null;
    }

}
